# Hands-On Application Development with Spring Boot 2 [Video]
This is the code repository for [Hands-On Application Development with Spring Boot 2 [Video]](https://www.packtpub.com/application-development/hands-application-development-spring-boot-2-video?utm_source=github&utm_medium=repository&utm_campaign=9781789137712), published by [Packt](https://www.packtpub.com/?utm_source=github). It contains all the supporting project files necessary to work through the video course from start to finish.
## About the Video Course
Spring Boot is the fastest way to get a Spring application up and running with the fewest lines of code and the least configuration. It aims to make development easy so you can create production-grade applications and services. The Spring framework provides a great toolkit for the development of complex applications. In this course, we’ll fully leverage Spring Boot’s capabilities to create a payment system application and secure it with Spring Security.

This course provides a hands-on approach to building a payment system application from scratch using Spring Boot 2.0. You’ll begin by setting up Spring Boot together with Spring’s most powerful feature: Dependency Injection. Then you’ll build a data access layer with Spring data and rework it to be highly performant using Spring data reactive. Next, you’ll learn about Spring rest and servlets and use it to expose resources via HTTP endpoints. 
Later you’ll use Spring MVC to build an interface for the payment system. Moving on, you’ll expose critical business metrics using MicroMeter library and Spring actuator with Prometheus library. Finally, you’ll package your application into a Docker container and deploy your application into the cloud.

<H2>What You Will Learn</H2>
<DIV class=book-info-will-learn-text>
<UL>
<LI>Use Spring Boot to bootstrap your application quickly 
<LI>Leverage the power of spring Dependency Injection with Spring Boot 
<LI>Expose resources via a REST endpoint 
<LI>Develop custom filters that intercept HTTP servlet requests 
<LI>Access data layer with Spring Data 
<LI>Make your data layer reactive with Spring Data Reactive 
<LI>Implement user interface for Spring Boot REST endpoints with MVC 
<LI>Secure your application with Spring Security 
<LI>Test your application in the integration way 
<LI>Make your app ready for production with Actuator and MicroMeter library </LI></UL></DIV>

## Instructions and Navigation
### Assumed Knowledge
To fully benefit from the coverage included in this course, you will need:<br/>
This course is for developers who want to get hands-on with Spring Boot and use it to develop their business applications. We assume that you have a working knowledge of the Java programming language. Prior knowledge of Spring Boot is not mandatory.
### Technical Requirements
This course has the following software requirements:<br/>
TECHNICAL REQUIREMENTS
This course has the following software requirements:
	•	Intellij IDEA
	•	JAVA jdk 1.8 at least
This course has been tested on the following system configuration:
	•	OS: MAC OSX3
	•	Processor: Intel i7 
	•	Memory: 16GB



## Related Products
* [Hands-On Microservices with Spring Boot 2.0 [Video]](https://www.packtpub.com/application-development/hands-microservices-spring-boot-20-video?utm_source=github&utm_medium=repository&utm_campaign=9781788991551)

* [Hands-On Spring Security 5.x [Video]](https://www.packtpub.com/application-development/hands-spring-security-5x-video?utm_source=github&utm_medium=repository&utm_campaign=9781789802931)

* [Machine Learning Projects with Java [Video]](https://www.packtpub.com/big-data-and-business-intelligence/machine-learning-projects-java-video?utm_source=github&utm_medium=repository&utm_campaign=9781789612455)

